<?php
namespace lib\db;
use core;

include("./base.php");

use lib\db\Base;

class Quote extends Base
{
	public function __construct() 
    {
		$types = 
		[
			"assembly",
			"part",
			"fastener",
			"process"
		];
		parent::__construct("quote",$types);
	}

	function get_linked($input = [])
	{
		$qty = core\getVal($input,"unit",1);

		$linked = $this->link->getLinked1($input);
		
		$data = core\getVal($linked,"data",[]);
		foreach($data as &$sub)
		{
			$s_qty = core\getVal($sub,"unit",0);
			$_qty =  $s_qty*$qty;
			$sub["unit"] = $_qty;
			$sub["desc"] = "Qty/Assy = $s_qty ; Total Qty = $_qty";
		}
		$linked["data"]= $data; 
		return $linked;
	}

	function get_bom($input=[])
	{
		$result = [];
		$stored = [];
		$res = $this->get_bom_linked($input);

		$found = core\getVal($res,"found",[]);
		$search = core\getVal($input,"search","");

		if(!empty($found))
		{
			$res_ = [];
			if($search)
			{
				foreach($found as $sub)
				{
					$name = strtolower(core\getVal($sub,"name",""));
	
					$ind = stripos($name,$search);
					if ($ind !== false) 
					{
						$res_[] =$sub;
					}
				}
			}
			else $res_ = $found;


			foreach($res_ as $sub)
			{
				$type = core\getVal($sub,"type","");
				$id = core\getVal($sub,"id",0);
				$unit = core\getVal($sub,"unit",1);

				$key = $type."_".$id;
				$stored_ = core\getVal($stored,$key,null);

				if($stored_)
				{
					$unit_ = core\getVal($stored_,"unit",1);
					$stored_["unit"] = $unit_+$unit;
					$stored[$key] = $stored_;
				}
				else $stored[$key] = $sub;
			}
		}

		foreach($stored as $sub)
		{
			$result["data"][] = $sub;
		}
		
		return $result;
	}

	function get_bom_linked($input=[])
	{
		$parent_unit = core\getVal($input,"unit",1);

		$type = core\getVal($input,"parent_type","");
		$input["child_types"] = $this->getChildTypes($type);

		$linked = $this->link->getLinked1($input);

		$result = [];
		$data = core\getVal($linked,"data",[]);
		
		$result["found"] = [];	
		
		if(!empty($data))
		{
			foreach($data as $sub)
			{
				$sub_unit = core\getVal($sub,"unit",1);
				$sub["unit"] = $sub_unit*$parent_unit;
				$result["found"][] = $sub;
				$req=[];
				$req["parent_type"] = core\getVal($sub,"type","");
				$req["parent_id"] = core\getVal($sub,"id",0);
				$req["unit"] = $sub_unit*$parent_unit;

				$sub_ = $this->get_bom_linked($req);

				$found = core\getVal($sub_,"found",[]);
				$result["found"] = array_merge($result["found"],$found);
			}
		}
		
		return $result;
	}

	function update_qty($input=[])
	{
		$data = core\getVal($input,"data",0);

		$qty = core\getVal($data,"unit",0);

		$req_view = [];
		$req_view["id"] =  core\getVal($data,"link_id",0);
		$res_view = $this->link->view($req_view);

		$sub =  core\getVal($res_view,array_key_first($res_view),[]);
		
		if($sub) $sub["unit"] = $qty;
		
		$req_link = [];
		$req_link["data"] = $sub;
		
		return $this->link->save($req_link);
	}

	function getChildTypes($type)
	{
		$child_types =[];
		switch ($type) 
		{
			case 'part':
			$child_types[] = "process";
			$child_types[] = "fastener";
			break;
			case 'assembly':
			case 'quote':
				$child_types[] = "assembly";
				$child_types[] = "part";
				$child_types[] = "process";
				$child_types[] = "fastener";
			break;
			
			default:
			# code...
			break;
		}

		return $child_types;
	}
}

$e = new Quote();